/********************************************************************
* jedlib.js                                                         *
* IBM ELS Development Team                                          *
* Last updated for KFP 1.0 1999.                                    *
********************************************************************/

var targetWindowOverride = this;
var audioType = null ;
var hotMediaTrackID = "" ;
var loadedHotMedia = false ;


function setTargetWindow(obj)
{
  	targetWindowOverride = obj ;
}

function getTargetWindow()
{
	return targetWindowOverride;
}

var ns = 0;
var ie = 0;

function checkBrowser()
{
	if (targetWindowOverride.document.layers)
	{
		ns = 1; ie = 0;
	}
	if (targetWindowOverride.document.all)
	{
		ns = 0; ie = 1;
	}
}

function isNetscape()
{
	return (ns == 1);
}

function isIE()
{
	return (ie == 1);
}


var mouseX = 0;
var mouseY = 0;

function setMouseMoveEvent(f)
{
	if (ns)
  		targetWindowOverride.document.captureEvents(Event.MOUSEMOVE);
		
	targetWindowOverride.document.onmousemove = f;
}
function setMouseDownEvent(f)
{
	if (ns)
  		targetWindowOverride.document.captureEvents(Event.MOUSEDOWN);
		
	targetWindowOverride.document.onmousedown = f;
}
function setMouseUpEvent(f)
{
	if (ns)
  		targetWindowOverride.document.captureEvents(Event.MOUSEUP);
		
	targetWindowOverride.document.onmouseup = f;
}

function getMouse(e) 
{
  if (ns) 
  {
    mouseX = e.pageX;
    mouseY = e.pageY;
  }
  else if (ie)
  {
    mouseX = event.clientX + targetWindowOverride.document.body.scrollLeft
    mouseY = event.clientY + targetWindowOverride.document.body.scrollTop;
  }
}

function escapeSingleQuotes(str)
{
	var re = /'/g;
	var s = str.replace(re,"\\'");
	return s;
}

function getLayer(name) 
{
  if (ns)
  {
	  return(targetWindowOverride.document.layers[name]);
  }
  
  if (ie) 
  {
    layer = eval('targetWindowOverride.document.all.' + name + '.style');
    return layer;
  }
  
  return null;
}

function makeArray(a) 
{
  var temp;

  if (!a.join) 
  {
    temp = a;

    a = new Array();
    a[0] = temp;
  }
  return a;
}

function newArray(n)
{	
	if (n <= 0)
		return null;
		
	a = new Array(n);
	
	for (var i=0; i < n; i++)
		a[i] = null;
		
	return a;
}

function hideLayer(name)
{
	var layer = getLayer(name);

	if (ns)
		layer.visibility = "hide";
	if (ie)
		layer.visibility = "hidden";
}


function showLayer(name) 
{
	var layer = getLayer(name);
	
	if (ns)
 		layer.visibility = "show";
	if (ie) 
		layer.visibility = "visible";
}

function hideShowLayer(name,hideshow)
{
	if (hideshow == 0)
		hideLayer(name);
	else
		showLayer(name);
}

function isVisible(name) 
{
	var layer = getLayer(name);

	if (ns && layer.visibility == "show")
 		return(true);
	if (ie && layer.visibility == "visible")
  		return(true);
	
	return(false);
}

function moveLayer(name, x, y) 
{
	var layer = getLayer(name);
	if (ns)
		layer.moveTo(x, y);
	if (ie) 
	{
		layer.pixelLeft = x;
    	layer.pixelTop  = y;
	}
}

function shiftLayer(name, x, y)
{
	var layer = getLayer(name);
	
	if (ns)
	{
		layer.left  +=x;
		layer.top   +=y;
	}
	else if (ie)
	{
		layer.pixelLeft +=x;
		layer.pixelTop  +=y;
	}
}

function resizeLayer(name,width,height)
{
	var layer = getLayer(name);
	
	if (ns)
	{
		layer.resizeTo(width,height);
	}
	else if (ie)
	{
		layer.width  = width;
		layer.height = height;
	}
}

function setBgColor(name, color)
{
 	var layer = getLayer(name);

	if (ns)
		layer.bgColor = color;
	else if (ie)
		layer.backgroundColor = color;
}

function setBgImage(name, imagesrc)
{
 	var layer = getLayer(name);

	if (ns)
		layer.background.src = imagesrc;
	else if (ie)
		layer.backgroundImage = "url(" + imagesrc + ")";
}

function setLayerHeight(name,height)
{
 	var layer = getLayer(name);

	if (ns)
	{
		layer.clip.height = height;
	}
	else if (ie)
		layer.pixelHeight = height;
}

function setLayerWidth(name,width)
{
 	var layer = getLayer(name);

	if (ns)
	{
		layer.clip.width = width;
	}
	else if (ie)
		layer.pixelWidth = width;
}

function replaceContent(name, content) 
{
	if (ns) 
	{    
		var layer = getLayer(name);
		layer.document.open();
		layer.document.writeln(content);
		layer.document.close();
	}
	else if (ie) 
	{
		var newContent = escapeSingleQuotes(content);
		var str = "targetWindowOverride.document.all." + name + ".innerHTML = '" + newContent + "'";
		eval(str);
	}
}

function getLeft(name) 
{
	var layer = getLayer(name);

	if (ns)
		return(layer.left);
	
	if (ie)
		return(layer.pixelLeft);
	
	return(null);
}

function getTop(name) 
{
	var layer = getLayer(name);

	if (ns)
		return(layer.top);
		
	if (ie)
		return(layer.pixelTop);

	return(null);
}

function getRight(name) 
{
	var layer = getLayer(name);

	if (ns)
		return(layer.left + layer.clip.width);
		
	if (ie)
		return(layer.pixelLeft + layer.pixelWidth);
		
    return(null);
}

function getBottom(name) 
{
	var layer = getLayer(name);

	if (ns)
		return(layer.top + layer.clip.height);
		
	if (ie)
		return(layer.pixelTop + layer.pixelHeight);
	
    return(null);
}

function getWidth(name) 
{
	var layer = getLayer(name);

	if (ns)
		return(layer.clip.width);
	if (ie)
		return(layer.pixelWidth);

    return(null)
}

function getHeight(name) 
{	
  	var layer = getLayer(name);
	
	if (ns)
		return(layer.clip.height);
	if (ie)
		return(layer.pixelHeight);

    return(null);
}

function getWinWidth() 
{
	if (ns)
		return(targetWindowOverride.window.innerWidth);
	if (ie)
		return(targetWindowOverride.document.body.clientWidth);
		
    return(null);
}

function getWinHeight() 
{
	if (ns)
		return(targetWindowOverride.window.innerHeight);
	if (ie)
		return(targetWindowOverride.document.body.clientHeight);

    return(null);
}

function getzIndex(name) 
{
	var layer = getLayer(name);

	if (ns || ie)
		return(layer.zIndex);

    return(null);
}

function setzIndex(name, z) 
{
	var layer = getLayer(name);

	if (ns || ie)
		layer.zIndex = z;
}

function getImgSrc(imagename) 
{
	var i, layer;
	var imgsrc = null;

	if (targetWindowOverride.document.images[imagename])
		return targetWindowOverride.document.images[imagename].src;

	if (ns)
		for (i = 0; i < targetWindowOverride.document.layers.length; i++) 
		{
			layer = targetWindowOverride.document.layers[i];

			if (layer.document.images[imagename])
        		imgsrc = layer.document.images[imagename].src;
    	}

	return imgsrc;
}

function setImgSrc(imagename, imagesrc) 
{
	var i, layer;

	if (targetWindowOverride.document.images[imagename]) 
	{
		targetWindowOverride.document.images[imagename].src = imagesrc;
		return;
	}

	if (ns) 
	{
		var found = false;

		for (i = 0; i < targetWindowOverride.document.layers.length && !found; i++) 
		{
			layer = targetWindowOverride.document.layers[i];

			if (layer.document.images[imagename]) 
			{
				layer.document.images[imagename].src = imagesrc;
				found = true;
			}
		}
	}
}


function getFormInLayer(layerName,formName)
{
	if (ns)
	{
		return (targetWindowOverride.document.layers[layerName].document.forms[formName]);
	}
	if (ie)
	{
		return (targetWindowOverride.document.all[formName]);
	}
}

function getForm(name)
{
	var i, layer;
	var form = null;
	
	if (targetWindowOverride.document.forms[name])
		form = targetWindowOverride.document.forms[name];
	
	if (ns)
	{
		for (i = 0; i < targetWindowOverride.document.layers.length; i++)
		{
			layer = targetWindowOverride.document.layers[i];
			if (layer.document.forms[name])
				form = layer.document.forms[name];
		}
	}
	return form;
}

function getFormElement(thisForm,elementName)
{
	return eval("thisForm."+elementName);
}

function getValue(thisForm,elementName)
{
	var e = getFormElement(thisForm,elementName);
	if (e)
		return e.value;
}

function setValue(thisForm,elementName,v)
{
	var e = getFormElement(thisForm,elementName);
	
	if (e)
		e.value = v;
}

function isChecked(thisForm,elementName)
{
	var e = getFormElement(thisForm,elementName);
	
	if (e && e.type == "checkbox")
		return e.checked;
		
	return false;
}

function setChecked(thisForm,elementName,b)
{
	var e = getFormElement(thisForm,elementName);

	if (e && e.type == "checkbox")
		e.checked = b;
}

function isSelected(thisForm,elementName,index)
{
	var e = getFormElement(thisForm,elementName);

	if (e && (e.type == "select-one" || e.type == "select-multiple"))
		return eval("e.options["+index+"].selected");
}

function setSelected(thisForm,elementName,index,b)
{
	var e;
	
	e = eval("thisForm."+elementName+".options["+index+"].selected");
	
	if (e)
		e.selected = b;
}

function getSelectedIndex(thisForm,elementName)
{
	var e = getFormElement(thisForm,elementName);

	if (e && (e.type == "select-one" || e.type == "select-multiple"))	
		return e.selectedIndex;
		
	return -1;
}

function getSelectedValue(thisForm,elementName)
{
	var idx = getSelectedIndex(thisForm,elementName);
	
	if (idx == -1)
		return null;
		
	return eval("thisForm."+elementName+".options["+idx+"].value");
}

function getSelectedText(thisForm,elementName)
{
	var idx = getSelectedIndex(thisForm,elementName);
	
	if (idx == -1)
		return null;
		
	return eval("thisForm."+elementName+".options["+idx+"].text");
}

function getCheckedRadioValue(thisForm,elementName)
{
	var e = getFormElement(thisForm,elementName);
	
	if (e[0] && e[0].type == "radio")
	{	
		for (var i=0; i < e.length; i++)
		{
			var e2 = eval("thisForm."+elementName+"["+i+"]");
			if (e2.checked)
				return e2.value;
		}
	}
	
	return null;
}


function hideAndClearAudioLayer(location) 
{
	var oldWin = getTargetWindow();  
  if (location.toLowerCase() != "contentframe")
	  setTargetWindow(top.navigation);
	if (audioType == "hotmedia")
  	stopAudio() ;
	audioType = null ;
  hideLayer("AudioLayer") ;
	setTargetWindow(oldWin);	
}


function insertAudio(name, audiofile, code, location, showControls, syncArray)
{
	var appletTag;
	var oldTargetWin = getTargetWindow();  
	setTargetWindow(top.navigation);	
  if (audiofile.indexOf(".wav") != -1) 
		embedAudio(name,audiofile);
  if (audiofile != "" && code != "")
	{	
    if (audiofile.indexOf(".mvr") != -1)
    {     
      audioType = "hotmedia" ;

      if (syncArray != null)
        hotMediaTrackID = 144 ;
      else
        hotMediaTrackID = 68 ;

      Lib.resetPauseButton(true) ;
    }
    if (loadedHotMedia) {
    	var myApplet = getHMApplet() ;
      if (myApplet != null)
      	myApplet.load(code + audiofile) ;
    }   
		else {
			replaceContent(name, getHotMediaAppletString(code, audiofile)) ; 
			loadedHotMedia = true ;
		}
    if (showControls.toLowerCase() == "true") {
      if (!isVisible(name))
      showLayer(name) ;
    }
	}
	setTargetWindow(oldTargetWin);	
}

function getHotMediaAppletString(code, audiofile) 
{
	var appletStr = "" ;
	appletStr += '<applet ARCHIVE=hotmedia.jar codebase="'+ code + 'applets/hotmedia" code="hm25.class" name="HMAudio" width="56" height="15" alt="Java not supported" MAYSCRIPT>' ;      
  appletStr += '<param name="mvrfile" value="'+ audiofile + '">' ;
  for (i = 1; i <= 30; i++) 
		appletStr += '<param name="jstoken' + i + '" value="top.engine.handleSync&'+ i + '">';
  appletStr += '</applet>' ; 
	return appletStr ;
}

function handleSync(index)
{
  if (index != "")
    top.control.handleMediaSyncEvent(parseInt(index)) ;	 
}


function getHMApplet()
{
  var myApplet = null ;
  if (top.engine.isNetscape())
	  myApplet=top.navigation.document.AudioLayer.document.applets["HMAudio"] ;
  if (top.engine.isIE())
    myApplet=top.navigation.document.all.AudioLayer.document.applets["HMAudio"] ;
  return myApplet ;
}

function stopAudio()
{
  Lib.resetPauseButton(false) ;
  var myApplet = getHMApplet() ;
  if (myApplet != null)
    myApplet.set(hotMediaTrackID,'TrackId', 'PlayerState=stop') ;
}

function pauseAudio()
{
  var myApplet = getHMApplet() ;
  if (myApplet != null)
    myApplet.set(hotMediaTrackID,'TrackId', 'PlayerState=pause') ;
}

function resumeAudio()
{
  var myApplet = getHMApplet() ;
  if (myApplet != null)
    myApplet.set(hotMediaTrackID,'TrackId', 'PlayerState=play') ;
}

function embedAudio(name,audiofile)
{
	if (audiofile != "")
	{
		embedTag = '<embed src="'+audiofile+'" hidden=true autostart=true width=2 height=2></embed>';
		replaceContent(name, embedTag);
	}
}

function setDocumentBgColor(color)
{
	if (color+"" == null || color+"" == "" || color+"" == "undefined")
		color = "transparent";
		
	if (ns)
		targetWindowOverride.document.bgColor = color;
	else if (ie)
		targetWindowOverride.document.all.body.style.backgroundColor = color;
}

function setDocumentBgImage(imagesrc)
{
	// ns not supported
	if (ie)
		targetWindowOverride.document.all.body.style.backgroundImage = "URL("+imagesrc+")";
}

function setLayerBorder(name, color, width, style)
{
	var layer = getLayer(name);
	
	layer.borderLeftColor = color;
	layer.borderLeftWidth = width;
	layer.borderLeftStyle = style;
	layer.borderTopColor = color;
	layer.borderTopWidth = width;
	layer.borderTopStyle = style;
	layer.borderRightColor = color;
	layer.borderRightWidth = width;
	layer.borderRightStyle = style;
	layer.borderBottomColor = color;
	layer.borderBottomWidth = width;
	layer.borderBottomStyle = style;
}

// debugging tool
var timestamp = 0;

function trace(label, value)
{
	var msg = label + "=" + value;
	var now = new Date();
	var elapsed = now -timestamp
	if (elapsed < 10000)
		msg += " (" + elapsed + " msec)";

	timestamp = now;
	if (ns)
		java.lang.System.out.println(msg);		
	else
		alert(msg);
}


function putLayoutCode(code, w)
{
	if (ns)
	{
		w.document.open("text/html");
		w.document.write("<html><body bgColor=white></body></html>");
		w.document.close();
		
		newCode = escapeSingleQuotes(code);
		var re = /\n/g;
		newCode = newCode.replace(re,"\\n");
		var i = newCode.indexOf("<");
		newCode = newCode.slice(i);
		newCode = "java\script:'" + newCode + "';";
		w.location.assign(newCode);
	}
	else
	{
		with (w.document)
		{
			open("text/html");
			writeln("") ;
			writeln(code);
			writeln("") ;
			close();
		}
	}
}

function processRightClick(evt)
{
	if (ns)
	{
		if (evt.which == 3)
			return false;
	}
	else
		alert(evt.event.srcElement.type);
		
	return true;
}

function disableLC()
{
	if (ns)
	{
		top.captureEvents(Event.MOUSEDOWN);
		top.onMouseDown = Lib.processLeftClick;	
	}

}

function enableLC()
{
	if (ns)
	{
		top.releaseEvents(Event.MOUSEDOWN);
	}
}


function disableRC()
{
	if (ns)
	{
		top.captureEvents(Event.MOUSEDOWN);
	}
	top.onMouseDown = Lib.processRightClick;
}

// Default values for navigation launcher 
var defaultLaunchURL;
var launcherHeight;
var launcherWidth;
var showChrome = true;

function setLaunchURL(aURL) 
{
	if (aURL!="")
		defaultLaunchURL=aURL;
}

function getDefaultURLValue() 
{
	return defaultLaunchURL; 
}

function setLaunchValues(aURL,aheight,awidth,show) 
{
	defaultLaunchURL = aURL; 
	launcherHeight = aheight;
	launcherWidth =	awidth;
	if (show=="true")
		showChrome = true;
	else
		showChrome = false;
}

function launchWindow(aURL,atoolbar,alocation,aheight,awidth,astatus,amenubar,ascrollbar,resize) 
{
	
	var options = atoolbar+","+alocation+","+aheight+","+awidth+","+astatus+","+amenubar+","+ ascrollbar + ","+ resize;

  if (aURL != "") {
	  var newWin = targetWindowOverride.open(aURL,"aWindow",options);
		newWin.focus() ;
	}	
}

function launchWindowFromNav() 
{
	
	aURL = defaultLaunchURL;
    if (aURL == "")
      return;
	var newWin ;
	if (showChrome) {
		var	options = "height="+launcherHeight+",width="+launcherWidth+",toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=no";
			newWin = targetWindowOverride.open(aURL,"aWindow",options);
			newWin.focus() ;
	} else {
		//duplicate browser settings
		var	options = "height="+launcherHeight+",width="+launcherWidth;
		newWin = targetWindowOverride.open(aURL,"aWindow",options);
		newWin.focus() ;
	}
}
	
function autoAdvance() 
{
  top.engine.doNavigation('NEXT') ;
}
